﻿using Newtonsoft.Json;
using System;
using System.Collections.ObjectModel;
using System.IO;

namespace GettingStartedBound
{
    public class FileManagerViewModel
    {
        #region Fields

        private ObservableCollection<ArrivalPrediction> imageNodeInfo;

        private object selectedItem;
        #endregion

        #region Constructor

        public FileManagerViewModel()
        {
            GenerateSource();
        }

        #endregion

        #region Properties

        public ObservableCollection<ArrivalPrediction> ImageNodeInfo
        {
            get { return imageNodeInfo; }
            set { this.imageNodeInfo = value; }
        }

        public object SelectedItem
        {
            get { return selectedItem; }
            set { this.selectedItem = value; }
        }

        #endregion

        #region Generate Source

        public void GenerateSource()
        {
            ImageNodeInfo = new ObservableCollection<ArrivalPrediction>();

            var reader = new JsonTextReader(new StringReader(JSONData.JSON));

            ArrivalPrediction ap = null;

            while (reader.Read())
            {
                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("vehicleId"))
                {
                    reader.Read();
                    ap = new ArrivalPrediction();
                    ap.VehicleId = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("lineId"))
                {
                    reader.Read();
                    ap.LineId = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("lineName"))
                {
                    reader.Read();
                    ap.LineName = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("platformName"))
                {
                    reader.Read();
                    ap.PlatformName = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("direction"))
                {
                    reader.Read();
                    ap.Direction = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("destinationName"))
                {
                    reader.Read();
                    ap.Destination = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("currentLocation"))
                {
                    reader.Read();
                    ap.CurrentLocation = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("towards"))
                {
                    reader.Read();
                    ap.Towards = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("expectedArrival"))
                {
                    reader.Read();
                    ap.ExpectedArrivalUTC = DateTime.SpecifyKind(DateTime.Parse(reader.Value.ToString()), DateTimeKind.Utc);
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("modeName"))
                {
                    reader.Read();
                    ap.Mode = (string)reader.Value;
                }

                if (reader.TokenType == JsonToken.PropertyName && reader.Value != null && reader.Value.Equals("received"))
                {
                    reader.Read();
                    ImageNodeInfo.Add(ap);
                }
            }
        }

        #endregion
    }
}